
#!/bin/sh
. /lib/functions.sh
val=0
updatepolicy(){
	cfg=$1
	val=$(( $val + 1 ))
	
	config_get methd "$cfg" method
	config_get enable "$cfg" enable
	if [ $enable == '1' ]; then
		leftno=`cat /tmp/etc/ipsec.conf  | grep -wn left  | cut -d: -f1 | head -$val | tail -1`
		[ $methd == "Static" ] && {
			config_get route "$cfg" route
			intrf=$route
		} || {
			config_get policy "$cfg" policy
			intrf=`mwan3 policies | grep -wA1 "Policy $policy" | tail -1 | cut -d" " -f2`
		}

		case "$intrf" in
			"wan")
			sed -i "${leftno}s/left=.*/left=${wan}/" /tmp/etc/ipsec.conf
			echo wan >  /tmp/ipsec_$cfg/interface
			;;
			"wwan")
			sed -i "${leftno}s/left=.*/left=${wwan}/" /tmp/etc/ipsec.conf
			echo wwan >  /tmp/ipsec_$cfg/interface
			;;
			"3g")
			sed -i "${leftno}s/left=.*/left=${cell}/" /tmp/etc/ipsec.conf
			echo 3g >  /tmp/ipsec_$cfg/interface
			;;
			"celldhcp")
			sed -i "${leftno}s/left=.*/left=${celldhcp}/"  /tmp/etc/ipsec.conf
			echo celldhcp >  /tmp/ipsec_$cfg/interface
			;;
			"cellular")
			sed -i "${leftno}s/left=.*/left=${cellular}/"  /tmp/etc/ipsec.conf
			echo cellular >  /tmp/ipsec_$cfg/interface
			;;
			* )
			echo "" >  /tmp/ipsec_$cfg/interface
			;;
		esac
	fi
}

wan=`ifstatus wan | grep "\"address\":" | awk -F ":" '{print$2}' |awk -F "\"" '{print$2}'`
if [ "$wan" == "" ]; then wan="127.0.0.1";
fi
wwan=`ifstatus wwan | grep "\"address\":" | awk -F ":" '{print$2}' |awk -F "\"" '{print$2}'`
if [ "$wwan" == "" ]; then wwan="127.0.0.1";
fi
cell=`ifstatus 3g | grep "\"address\":" | head -1 |awk -F ":" '{print$2}' |awk -F "\"" '{print$2}'`
if [ "$cell" == "" ]; then cell="127.0.0.1";
fi
celldhcp=`ifstatus celldhcp | grep "\"address\":" | head -1 |awk -F ":" '{print$2}' |awk -F "\"" '{print$2}'`
if [ "$celldhcp" == "" ]; then celldhcp="127.0.0.1";
fi
cellular=`ifstatus cellular | grep "\"address\":" | head -1 |awk -F ":" '{print$2}' |awk -F "\"" '{print$2}'`
if [ "$cellular" == "" ]; then cellular="127.0.0.1";
fi


config_load ipsec
config_foreach updatepolicy ipsec
ipsec update 
