#!/bin/sh
. /lib/functions.sh

uptime()
{
	connc="$1"
	cfg="$2"
	tm=`cat /tmp/ipsecstatus | grep -w -E "$connc.*ESTABLISHED" | awk -v FS="(ESTABLISHED|ago)" '{print $2}'`
	tm1=`echo $tm | awk '{print $2}'`
	tm2=`echo $tm | awk '{print $1}'`
	sec=0
	hr=0
	min=0
	case ${tm1} in
		s*)
sec=$tm2
;;
m*)
min=$tm2
sec=`echo $tm | awk -v FS="(min|sec.*)" '{print $2}' | cut -d ' ' -f2`
;;
h*)
hr=$tm2
min=`echo $tm | awk -v FS="(ho|mi.*)" '{print $2}' | cut -d ' ' -f2`
sec=`echo $tm | awk -v FS="(mi|se.*)" '{print $2}' | cut -d ' ' -f2`
;;
w*)

;;
esac
tim=$((hr*60*60+min*60+sec))
left=`cat /tmp/ipsecstatus | grep -w $connc | grep child | awk '{print $3}' | cut -d '/' -f1`	
right=`cat /tmp/ipsecstatus | grep -w $connc | grep child | awk '{print $5}' | cut -d '/' -f1`
left_subnet=`cat /tmp/ipsecstatus | grep -w $connc | grep child | awk '{print $3}' | cut -d '/' -f2`
right_subnet=`cat /tmp/ipsecstatus | grep -w $connc | grep child | awk '{print $5}' | cut -d '/' -f2`	
ip_by=`cat /tmp/ipsecstatus  | grep -w $connc | grep rekey  | cut -d',' -f 2 | cut -d' ' -f 2 | tail -1`
if [ $ip_by -eq 0 ]
	then
	ip_pt=0
	op_by=`cat /tmp/ipsecstatus  | grep -w $connc |grep rekey  | cut -d',' -f 3 | cut -d' ' -f 2 | tail -1`
	if [ $op_by -eq 0 ]
		then
		op_pt=0
	else
		op_pt=`cat /tmp/ipsecstatus | grep -w $connc | grep -i rekey | cut -d , -f 3 | cut -d'(' -f 2 | cut -d' ' -f1 | tail -1`
	fi
else
	ip_pt=`cat /tmp/ipsecstatus  | grep -w $connc | grep -i rekey | cut -d',' -f 2 | cut -d'(' -f 2 | cut -d' ' -f1 | tail -1`
	op_by=`cat /tmp/ipsecstatus  | grep -w $connc | grep -i rekey | cut -d',' -f 4 | cut -d' ' -f2 | tail -1`
	if [ $op_by -eq 0 ]
		then
		op_pt=0
	else
		op_pt=`cat /tmp/ipsecstatus  | grep -w $connc | grep -i rekey | cut -d',' -f 4 | cut -d'(' -f 2 | cut -d' ' -f1 | tail -1`
	fi
fi

echo "$tim" "$op_by" "$ip_by" "$ip_pt" "$op_pt" "$left" "$left_subnet" "$right" "$right_subnet" > /tmp/ipsec_$cfg/params
	#echo "$tim" "$op_by" "$ip_by" "$ip_pt" "$op_pt" "$left" "$left_subnet" "$right" "$right_subnet"
	ipsecstatus=`cat /tmp/ipsec_$cfg/status`
	if [[ $tim -gt 0 ]] && [[ "$ipsecstatus" != "4" ]] && [[ "$op_by" != "" ]]
		then
		echo 2 > /tmp/ipsec_$cfg/status
	else
		if [[ "$ipsecstatus" != "1" ]] && [[ "$ipsecstatus" != "4" ]]
			then
			echo 3 > /tmp/ipsec_$cfg/status
		fi
	fi

}

statusload(){
	local cfg="$1"
	echo cfg=$cfg
	config_get conn "$cfg" conn
	config_get enable "$cfg" enable
	if [ "$enable" == "1" ]
		then
		configavailable=`expr $configavailable + 1 `
		ipsecstatus=`cat /tmp/ipsec_$cfg/status`
		if [ "$ipsecstatus" == "2" -o "$ipsecstatus" == "3" ]
			then
			uptime "$conn" "$cfg"
		fi
	fi
}

ipold=`ps w | grep 'ipsecwatchdog' | grep -v grep | wc -l`          
if [ $ipold == 0 ]
	then
	ipsecwatchdog &
fi

local configavailable
while [ 1 ];do
	configavailable=0
	ipsec statusall > /tmp/ipsecstatus 2>/dev/null
	config_load ipsec
	config_foreach statusload ipsec
	if [ $configavailable -eq 0 ];then
		break;
	fi
	sleep 5
done

